"""Add metric metadata

Revision ID: 87cf9c00ac00
Revises: 58e246fba34b
Create Date: 2023-10-24 03:54:04.755698+00:00

"""
# pylint: disable=no-member, invalid-name, missing-function-docstring, unused-import, no-name-in-module

import sqlalchemy as sa
import sqlmodel

from alembic import op

# revision identifiers, used by Alembic.
revision = "87cf9c00ac00"
down_revision = "58e246fba34b"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "metricmetadata",
        sa.Column(
            "direction",
            sa.Enum(
                "HIGHER_IS_BETTER",
                "LOWER_IS_BETTER",
                "NEUTRAL",
                name="metricdirection",
            ),
            nullable=True,
        ),
        sa.Column(
            "unit",
            sa.Enum(
                "UNKNOWN",
                "UNITLESS",
                "PERCENTAGE",
                "PROPORTION",
                "USD",
                "SECOND",
                "MINUTE",
                "HOUR",
                "DAY",
                "WEEK",
                "MONTH",
                "YEAR",
                name="metricunit",
            ),
            nullable=True,
        ),
        sa.Column("id", sa.Integer(), nullable=False),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_metricmetadata")),
    )
    with op.batch_alter_table("noderevision", schema=None) as batch_op:
        batch_op.add_column(
            sa.Column("metric_metadata_id", sa.Integer(), nullable=True),
        )
        batch_op.create_foreign_key(
            batch_op.f("fk_noderevision_metric_metadata_id_metricmetadata"),
            "metricmetadata",
            ["metric_metadata_id"],
            ["id"],
        )

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("noderevision", schema=None) as batch_op:
        batch_op.drop_constraint(
            batch_op.f("fk_noderevision_metric_metadata_id_metricmetadata"),
            type_="foreignkey",
        )
        batch_op.drop_column("metric_metadata_id")

    op.drop_table("metricmetadata")
    # ### end Alembic commands ###
